package ap;

import ap.proof.{ModelSearchProver, Timeout}
import ap.terfor.conjunctions.{Conjunction, Quantifier}
import ap.util.Debug
import ap.parameters.{GoalSettings, PreprocessingSettings}

object FileModelSearcher {
  
  private val AC = Debug.AC_PROVER
  
}

class FileModelSearcher(reader : java.io.Reader, output : Boolean,
                        preprocSettings : PreprocessingSettings,
                        goalSettings : GoalSettings)
      extends AbstractFileProver(reader, output, Math.MAX_INT, false,
                                 preprocSettings, goalSettings) {

  //////////////////////////////////////////////////////////////////////////////
  Debug.assertCtor(FileModelSearcher.AC,
                   (formula.constants subsetOf eliminatedConstants) &&
                   (Conjunction.collectQuantifiers(formula) subsetOf Set(Quantifier.ALL)))
  //////////////////////////////////////////////////////////////////////////////
  
  val counterModel : Conjunction =
    Timeout.catchTimeout {
      findCounterModel
    } {
      case _ => Conjunction.FALSE
    }
  
}
